
/*
 * XKOBO, a video-oriented game
 * Copyright (C) 1995,1996  Akira Higuchi
 *     a-higuti@math.hokudai.ac.jp
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

#include "tiff.h"
#include "xkobo.h"

#include "images.c"

/********    tiny TIFF loader  ( 256 colors, not compressed )   ********/

static int pos_image   = 0;
static int pos_cmap    = 0;
static int sizex       = 0;
static int sizey       = 0;
static int endianness;

int link_tiff(unsigned char *data, win_cmap& wcm, win_chip& wch)
{
	int i;
	unsigned short *px = gfx;
	for (i = 0; i < (gfxh * gfxw); i++) {
		if (*px == 0x1f) *px |= 0x8000;
		*px++;
	}
    Screen scr = {gfxw, gfxh, 0, gfx};
    wch.fill_chip(&scr);
    wcm.cmset();
    return 0;
}

