
/*
 * XKOBO, a video-oriented game
 * Copyright (C) 1995,1996  Akira Higuchi
 *     a-higuti@math.hokudai.ac.jp
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */

#ifndef XKOBO_H_XLBACKING
#define XKOBO_H_XLBACKING

#include "xlwin.h"
#include "renderer/raster.h"

class win_backing : public win{

  protected:
    unsigned short fgcolor;
    unsigned short bgcolor;
    Screen *p;
    
  public:
    int endx, endy;
    win_backing();
    virtual ~win_backing();
    void make(win *back,int wx=0,int wy=0,int sizex=200,int sizey=200);
    int eventloop();
    void clear();
    void clear(int x,int y,int h,int v);
    virtual void expose_backing();                 /* from eventroop() */
    void foreground(unsigned short c);
    void background(unsigned short c);
    void font(char *s);
    void warp_pointer(int x, int y);
    void Image_Blit(Screen *pImage, int dx, int dy, int sx, int sy, int sw, int sh);
    void string(int x, int y, char *t);
    void string_back(int x, int y, char *t);
    void fillrectangle_back(int x, int y, int h, int v);
    inline void point(int x, int y) {
	    rast_pixel(NULL, x + endx, y, fgcolor);
    	rast_pixel(p, x, y, fgcolor);}
    inline void point_back(int x, int y) {
	rast_pixel(p, x, y, fgcolor);
	    rast_pixel(NULL, x + endx, y, fgcolor);}
    inline void flush() {
	    rast_flip();}
    inline void back(){
	    rast_blit(NULL, p, endx, endy, 0, 0, sx, sy);}
    inline void back(int x, int y, int h, int v){
	    rast_blit(NULL, p, x, y, x, y, h, v);}
    inline void dpoint(int x, int y) {
	    int rx = x << 1, ry = y << 1;
	    rast_pixel(NULL, rx + endx, ry , fgcolor);
	rast_pixel(NULL, rx + endx+1, ry , fgcolor);
	rast_pixel(NULL, rx + endx, ry+1 , fgcolor);
	rast_pixel(NULL, rx + endx+1, ry+1 , fgcolor);

	rast_pixel(p, rx, ry , fgcolor);
	rast_pixel(p, rx+1, ry , fgcolor);
	rast_pixel(p, rx, ry+1 , fgcolor);
	rast_pixel(p, rx+1, ry+1 , fgcolor);
    }


};

#endif // XKOBO_H_XLBACKING
